// Win32_AnimatedWindow.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "Win32_AnimatedWindow.h"
#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name
HWND g_hAnimatedWnd;

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
void ShowSampleWindow(HINSTANCE hInst, HWND hWnd);
LRESULT APIENTRY AnimatedWindow_WndFunc(HWND hWnd, UINT Message, WPARAM wParam, LONG lParam);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_WIN32_ANIMATEDWINDOW, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_WIN32_ANIMATEDWINDOW);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_WIN32_ANIMATEDWINDOW);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_WIN32_ANIMATEDWINDOW;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
                               300, 300, 500, 500, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szError[10];

	switch (message) 
	{
    case WM_CREATE:
		ShowSampleWindow(hInst, hWnd);
		break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
		case ID_COMMANDS_ANIMATE_LEFT2RIGHT:
			ShowWindow(g_hAnimatedWnd, SW_HIDE);
		    AnimateWindow(g_hAnimatedWnd, 1000, AW_SLIDE | AW_HOR_POSITIVE); 
			break;
		case ID_COMMANDS_ANIMATE_RIGHT2LEFT:
		    ShowWindow(g_hAnimatedWnd, SW_HIDE);
		    AnimateWindow(g_hAnimatedWnd, 1000, AW_SLIDE | AW_HOR_NEGATIVE);
			break;
		case ID_COMMANDS_ANIMATE_TOP2BOTTOM:
			ShowWindow(g_hAnimatedWnd, SW_HIDE);
            AnimateWindow(g_hAnimatedWnd, 1000, AW_SLIDE | AW_VER_POSITIVE);
			break;
		case ID_COMMANDS_ANIMATE_BOTTOM2TOP:
			ShowWindow(g_hAnimatedWnd, SW_HIDE);
		    AnimateWindow(g_hAnimatedWnd, 1000, AW_SLIDE | AW_VER_NEGATIVE);
			break;
		case ID_COMMANDS_ANIMATE_OUTWARDS:
			ShowWindow(g_hAnimatedWnd, SW_HIDE);
		    AnimateWindow(g_hAnimatedWnd, 1000, AW_ACTIVATE | AW_CENTER);
			break;
		case ID_COMMANDS_ANIMATE_INWARDS:
			ShowWindow(g_hAnimatedWnd, SW_SHOW); // or UpdateWindow
		    AnimateWindow(g_hAnimatedWnd, 1000, AW_HIDE | AW_CENTER);
			break;
		case ID_COMMANDS_ANIMATE_BLEND:
			// Window used for blend animation must not be a child, and must be 
			// a top-level window. Therefore former child window used for other 
			// types of animations is destroyed, and popup window is created
			// instead with WS_EX_TOPMOST flag to make it top-level window as
			// required for blind animation.
			DestroyWindow(g_hAnimatedWnd);
			g_hAnimatedWnd = CreateWindowEx(WS_EX_TOPMOST, "AnimatedWindow",  
		        "", WS_POPUP | WS_VISIBLE, 350, 380, 400, 400, HWND_DESKTOP, 0, 
				                                                      hInst, 0);
			ShowWindow(g_hAnimatedWnd, SW_HIDE);
		    if (AnimateWindow(g_hAnimatedWnd, 5000, AW_BLEND) == 0 /* error */)
			{
				wsprintf(szError, "%d", GetLastError());
				MessageBox(0, szError, "AnimateWindow Error!", 0);

				if (GetLastError() == ERROR_SUCCESS) 
					MessageBox(0, szError, 
					                   "AnimateWindow ERROR_SUCCESS Error!", 0); 
			}
			break;
		case ID_COMMANDS_ANIMATE_BLEND_HIDE:
			// See comments for previous case - blend (show).
			DestroyWindow(g_hAnimatedWnd);
			g_hAnimatedWnd = CreateWindowEx(WS_EX_TOPMOST, "AnimatedWindow",  
		        "", WS_POPUP | WS_VISIBLE, 350, 380, 400, 400, HWND_DESKTOP, 0, 
				                                                      hInst, 0);
			ShowWindow(g_hAnimatedWnd, SW_SHOW);
			if (AnimateWindow(g_hAnimatedWnd, 5000, 
				                           AW_BLEND | AW_HIDE) == 0 /* error */)
			{
				wsprintf(szError, "%d", GetLastError());
				MessageBox(0, szError, "AnimateWindow Error!", 0);

				if (GetLastError() == ERROR_SUCCESS) 
					MessageBox(0, szError, 
					                   "AnimateWindow ERROR_SUCCESS Error!", 0); 
			}
            break;
		case IDM_ABOUT:
			DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}

void ShowSampleWindow(HINSTANCE hInst, HWND hWnd)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)AnimatedWindow_WndFunc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInst;
	wcex.hIcon			= 0;
	wcex.hCursor		= NULL;
	wcex.hbrBackground  = (HBRUSH)(COLOR_3DFACE+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= "AnimatedWindow";
	wcex.hIconSm		= NULL;

	RegisterClassEx(&wcex);

	// One can use WS_CHILD for all types of animations except blind animation,
	// which requires that animated window must not be a child window, and
	// also requires that it must be a top-level window. The window for blind 
	// animation is created in window procedure.
	g_hAnimatedWnd = CreateWindowEx(WS_EX_CLIENTEDGE, "AnimatedWindow", "", 
		            WS_VISIBLE | WS_CHILD, 50, 20, 400, 400, hWnd, 0, hInst, 0);
}

// MSDN (AnimateWindow): "The window procedures for the window and its child 
// windows should handle any WM_PRINT or WM_PRINTCLIENT messages. Dialog 
// boxes, controls, and common controls already handle WM_PRINTCLIENT. The 
// default window procedure already handles WM_PRINT."
LRESULT APIENTRY AnimatedWindow_WndFunc(HWND hWnd, UINT Message, 
                                                    WPARAM wParam, LONG lParam)
{
	HDC hdc;
	RECT rc;
	HBRUSH hbrush;

	switch (Message)
	{
	// MSDN (WM_PRINTCLIENT): "The AnimateWindow function requires that the 
	// window being animated implement the WM_PRINTCLIENT message." and "A  
	// window can process this message in much the same manner as WM_PAINT, 
	// except that BeginPaint and EndPaint need not be called (a device context 
	// is provided), and the window should draw its entire client area rather 
	// than just the invalid region."
	case WM_PRINTCLIENT:
		hdc = (HDC)wParam;  // provided device context
		GetClientRect(hWnd, &rc);
		hbrush = CreateSolidBrush(RGB(0, 255, 0)); // green for animated window
		FillRect(hdc, &rc, hbrush); 
		break;
	default:
		return DefWindowProc( hWnd, Message, wParam, lParam );
	}

	return 1;
}


